/*
* sketch de dessin collaboratif.
* Basé sur un modèle client/serveur
* avec utilisation de socket.
*/

// Création d'un socket (prise) pour connection au serveur.
var socket;
var x,y,delta;

function setup() {
  createCanvas(windowWidth,windowHeight);
  // on active le socket qui va permettre une communication bi-directionnelle 
  // avec le serveur (io :  input/output --> entrèe/sortie )
  socket = io();
  // mouseMsgProcess (traitement message 'mouse' ) est la fonction à appeler
  // lors de la reception de messages type 'mouse'  
  socket.on('serialDataFromServer',serialDataFromServerMsgProcess);
  fill(0,0,255);   noStroke(); 
  x=100;  y=100; delta=0;
  ellipse(x,y,10,10);	
}

function draw() {
  // On envoi le message tagué 'serialDataRequest' vers le serveur via le socket.
  // Ce message ne contient pas de data.
  socket.emit('serialDataRequestToServer'); 
}

// fonction appelé lors de la réception d'un message 'serial2'
function serialDataFromServerMsgProcess(angle) {
  // le contenu du message 'mouse' contient les coordonnées de la souris
  // des autres clients.
  delta = parseInt(angle);
  console.log(delta);  
  x=x+delta;
  if (x < 0) x=0;
  if (x > windowWidth) x = windowWidth;
  background(0); 
  console.log('xxxxxx : '+x);    
  ellipse(x,y,10,10);	  
}