const SerialPort = require('serialport');
const Readline = SerialPort.parsers.Readline;
const port = new SerialPort('COM4', {baudRate: 115200});
const parser = port.pipe(new Readline());

var angle;
parser.on('data', function (data) {
  var res = data.split(":");
  console.log('Data: ' + res[0]+'-->'+res[1]);
  angle=res[1];
});



//===================================
// code serveur node.js de p5jserver
//===================================

// Mise en place du serveur web express
var express = require('express');
var app = express();

// Le serveur est disponible à partir du port 3000
var server = app.listen(3000);

// Le serveur sert les fichiers présents dans le répertoire public.
// le fichier index.html si présent est servi par défaut.
app.use(express.static('public'));

console.log('\np5jserver running');
console.log('En attente de connections sur le port 3000 ...');

// Mise en place des outils de communication via les sockets.
var sockets = require('socket.io');
var io = sockets(server);

// Fonction à appeler lors d'une demande de connection.
// Ici il s'agit de la fonction newConnection().
io.on('connection',newConnection);

// Fonction activée à chaque nouvelle demande de connection.
function newConnection(socket){
	console.log('new connection : '+socket.id);
	console.log('Adresse IPv6 : '+socket.request.connection.remoteAddress);
	console.log('num port : '+socket.request.connection.remotePort);	
	// Foction à appeler lors de la réception d'un message 'mouse'
	// venant d'un client.
	socket.on('serialDataRequestToServer',broadcastMouseMsg);
	
	// Fonction exécutée à chaque reception d'un message 'mouse'
	// le paramètre data correspond au contenu du message envoyé.
	function broadcastMouseMsg() {
		// On diffuse le message, le mot anglais broadcast signifie diffuser !
		socket.emit('serialDataFromServer',angle.toString());  // A tous les autres clients connectés.
		//Autres variantes possibles, à choisir suivant les besoins :
		//socket.emit('mouse',data); // Au client emetteur et à lui seul
		//io.emit('mouse',data); // A tous les clients y compris l'emetteur
		console.log(angle);
	};
	
}
